package clase05.fia.ues.sv.clase05;

import android.app.AlertDialog;
import android.app.Dialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Color;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.ContextMenu;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.Toast;

public class MainActivity extends AppCompatActivity {
    static final int DIALOGO_ERROR_COLOR = 0;
    static final int DIALOGO_SELECCIONAR_COLOR = 1;

    final CharSequence[] items = { "Rojo", "Verde", "Azul" };

    EditText NombreColor;
    Button CambiarColor;
    LinearLayout Contenedor;

    @Override
    public void onCreate(Bundle saved) {
        super.onCreate(saved);
        setContentView(R.layout.activity_main);
        NombreColor = (EditText) this.findViewById(R.id.nombrecolor);
        CambiarColor = (Button) this.findViewById(R.id.boton);
        Contenedor = (LinearLayout) this.findViewById(R.id.contenedor);
        CambiarColor.setOnClickListener(onClick);
        //El menu contextual se define para la EditText Nombrecolor
        registerForContextMenu(NombreColor);
    }

    View.OnClickListener onClick = new View.OnClickListener() {

        @Override
        public void onClick(View arg0) {
            // TODO Auto-generated method stub
            int col = 0;
            try {
                col = Color.parseColor(NombreColor.getText().toString());
            } catch (Exception ex) {
                showDialog(DIALOGO_ERROR_COLOR);
            }
            //Contenedor.setBackgroundColor(col);
            Intent intent=new Intent(MainActivity.this,SecondActivity.class);
            intent.putExtra("Color", col);
            intent.putExtra("Mensaje", "Cambio Color usuario");

            MainActivity.this.startActivity(intent);
        }
    };

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = this.getMenuInflater();
        inflater.inflate(R.menu.menuprincipal, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case R.id.seleccionarcolor:
                showDialog(DIALOGO_SELECCIONAR_COLOR);
                return true;
            case R.id.menucambiarcolor:
                int col = 0;
                try {
                    col = Color.parseColor(NombreColor.getText().toString());
                } catch (Exception ex) {
                    showDialog(DIALOGO_ERROR_COLOR);
                }
                Contenedor.setBackgroundColor(col);
                return true;
            case R.id.cerrar:
                this.finish();
                return true;
            default:
                return super.onOptionsItemSelected(item);
        }
    }

    @Override
    public void onCreateContextMenu(ContextMenu menu, View v,
                                    ContextMenu.ContextMenuInfo info) {
        super.onCreateContextMenu(menu, v, info);
        //El view que activa el menu es el EditText llamado nombrecolor
        switch (v.getId()) {
            case R.id.nombrecolor:
                MenuInflater inflater = getMenuInflater();
                inflater.inflate(R.menu.menucolores, menu);
                break;
        }
    }

    @Override
    public boolean onContextItemSelected(MenuItem item) {
        //El Layout menucolores.xml tiene definidos los ids colorazul, colorrojo y colorverde
        //segun la seleccion de esta opcion en el menu contextual
        // se establece el valor al text del color

        switch (item.getItemId()) {
            case R.id.colorazul:
                NombreColor.setText("#0000ff");
                return true;
            case R.id.colorrojo:
                NombreColor.setText("#ff0000");
                return true;
            case R.id.colorverde:
                NombreColor.setText("#00ff00");
                return true;
            default:
                return super.onContextItemSelected(item);
        }
    }

    @Override
    public Dialog onCreateDialog(int dialog) {
        Dialog d = null;
        switch (dialog) {
            case DIALOGO_ERROR_COLOR:
                AlertDialog.Builder builder = new AlertDialog.Builder(this);
                builder.setMessage("Ha ingresado un color que es invalido. Puede ingresar el nombre del color en ingles o su codigo RGB con la sintaxis #RRGGBB");
                builder.setTitle("Error");
                builder.setCancelable(true);
                builder.setPositiveButton("OK",
                        new DialogInterface.OnClickListener() {

                            @Override
                            public void onClick(DialogInterface dialog, int which) {
                                // TODO Auto-generated method stub
                                dialog.dismiss();
                            }
                        });
                AlertDialog alert = builder.create();
                d = (Dialog) alert;
                break;
            case DIALOGO_SELECCIONAR_COLOR:
                Toast.makeText(getApplicationContext(), "Color Azul", Toast.LENGTH_LONG).show();
                NombreColor.setText("#0000ff");

                break;
        }
        return d;
    }
}
